import java.util.*;
import javax.bluetooth.*;


/**
 * @author Michel Deriaz
 */ 
public class BTDevices implements Runnable, DiscoveryListener {
  Vector devices;
  Vector friendlyNames;
  Vector deviceClasses;
  boolean isSearching;


  public BTDevices() {
    isSearching = true;
    devices = new Vector();
    friendlyNames = new Vector();
    deviceClasses = new Vector();
    Thread runner = new Thread(this);
    runner.start();
  }


  public Vector getDevices() {
    return devices;
  }


  public Vector getFriendlyNames() {
    return friendlyNames;
  }
 
 
  public Vector getDeviceClasses() {
    return deviceClasses;
  }
  
 
  public RemoteDevice getRemoteDevice(int i) {
    return (RemoteDevice)devices.elementAt(i);
  }
  
      
  public void waitUntilFinished() {
    while (isSearching) Thread.yield();
  }
      
     
  public void run() {
    try {
      DiscoveryAgent discoveryAgent = LocalDevice.getLocalDevice().getDiscoveryAgent();
      discoveryAgent.startInquiry(DiscoveryAgent.GIAC, this);
    }
    catch (Exception e) {
      System.out.println("BTDevices.run: " + e);
    }
  }


  public void deviceDiscovered(RemoteDevice btDevice, DeviceClass cod) {
    try {
      devices.addElement(btDevice);
      friendlyNames.addElement(btDevice.getFriendlyName(false));
      deviceClasses.addElement(cod);
    }
    catch (Exception e) {
      System.out.println("BTDevice.deviceDiscovered: " + e);
    }
  }


  public void inquiryCompleted(int discType) {
    isSearching = false;
  }


  public void servicesDiscovered(int transID, ServiceRecord[] servRecord) {}
  public void serviceSearchCompleted(int transID, int respCode) {}
}